---------------------
PatchSet 4625 
Date: 2007/05/20 08:15:36
Author: amosjeffries
Branch: ayjwork
Tag: (none) 
Log:
Final hardening of memAlloc in SqString

Members: 
	src/SqString.cc:1.1.2.13->1.1.2.14 

Index: squid3/src/SqString.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/SqString.cc,v
retrieving revision 1.1.2.13
retrieving revision 1.1.2.14
diff -u -r1.1.2.13 -r1.1.2.14
--- squid3/src/SqString.cc	20 May 2007 07:45:41 -0000	1.1.2.13
+++ squid3/src/SqString.cc	20 May 2007 08:15:36 -0000	1.1.2.14
@@ -1,6 +1,6 @@
 
 /*
- * $Id: SqString.cc,v 1.1.2.13 2007/05/20 07:45:41 amosjeffries Exp $
+ * $Id: SqString.cc,v 1.1.2.14 2007/05/20 08:15:36 amosjeffries Exp $
  *
  * DEBUG: section 67    String
  * AUTHOR: Duane Wessels
@@ -195,8 +195,9 @@
     } else {
         unsigned int ssz = len_ + len;
         unsigned int bsz = len_ + len + 1;
-        char* tmp = (char *)memAllocString(ssz, &bsz);
+        char* tmp = (char *)memAllocString(bsz, &bsz);
         assert(bsz < 65536);
+        assert(bsz > ssz);
 
         if (buf_)
             xmemcpy(tmp, buf_, len_);
@@ -204,7 +205,7 @@
         if (len)
             xmemcpy(tmp + len_, str, len);
 
-        tmp[ssz + 1] = '\0';
+        tmp[ssz] = '\0';
 
         clear();
 
